function goodCount(name="")
{
    if (name=="")return countDroid(DROID_ANY,me)/getDroidLimit(me)

    if (!isStructureAvailable(name))return 1
    var base=getStructureLimit(name,me)
    if (name=="A0ResourceExtractor")base=getStructureLimit("A0PowerGenerator",me)*4
    if (base==0)return 1    
    return enumStruct(me,name).length/base
}

function goodTarget(object)
{
    if (object==undefined) return 0
    if (object.type==STRUCTURE)
    {
        switch (object.stattype) {
            case FACTORY: return -20000         
            case RESEARCH_LAB:  return -10000
            case CYBORG_FACTORY:return -5000
            case POWER_GEN:return -500        
            case OIL_RESOURCE:return -100
            default:return -object.cost
        }
    }
    if (object.type==DROID)return -object.cost
    return 0
}

function goodResearch(name="")
{
    var coefDroid=countDroid(DROID_ANY,me) / getDroidLimit(me)
    var hasRail=getResearch("R-Wpn-RailGun01").started || getResearch("R-Wpn-RailGun01").done
    var hasHowitzer=getResearch("R-Wpn-HowitzerMk1").started || getResearch("R-Wpn-HowitzerMk1").done
    var cost=getResearch(name).power

    if (getResearch(name).started)return 999

    if (name.startsWith("R-Sys-Sensor-Turret"))return -100
    if (name=="R-Sys-Sensor-Tower01")return -100  
    if (name=="R-Struc-CommandRelay")return -100
    if (name=="R-Struc-Research-Module")return -100
    if (name=="R-Vehicle-Engine01")return -50
    if (name=="R-Struc-PowerModuleMk1")return -50
    if (name=="R-Wpn-Cannon1Mk1")return -40
    if (!componentAvailable(undefined,"Cannon1Mk1") & (name.startsWith("R-Wpn-MG")))return -30
    if (name=="R-Struc-Factory-Cyborg")return -20
    if (name=="R-Vehicle-Prop-Halftracks")return -15
    if (name=="R-Defense-HardcreteWall")return -10
    if (name=="R-Sys-MobileRepairTurret01")return -5
    if (name=="R-Sys-Sensor-Tower02")return 0.6

    if (name.startsWith("R-Sys-Autorepair-General"))return -100
    if (name.startsWith("R-Wpn-Rail"))return -20
    if (name.startsWith("R-Struc-Research-Upgrade"))return -10


    if (name.startsWith("R-Struc-Power"))return -.8+playerPower(me)/1200+name.endsWith("b")+name.endsWith("c")
    if (name.startsWith("R-Struc-Factory"))return 1.7-playerPower(me)/2500//+enumDroid(me).length/100

    if (name.startsWith("R-Wpn-Cannon-"))return 0.2+name.includes("Accuracy")*0.2+name.includes("ROF")*0.3+getResearch("R-Wpn-RailGun01").started+getResearch("R-Wpn-RailGun01").done
    if (name.startsWith("R-Cyborg-Hvywpn"))return .3
    if (name.startsWith("R-Wpn-Cannon"))return 0+name.endsWith("Cannon5")*2+cost/600


    if (name.includes("AAGun"))return 1.2-componentAvailable(undefined,"V-Tol")

    if (name.startsWith("R-Vehicle-Body"))return 0.3+(!(name.includes("1")|name.includes("5")))//|x.includes("2")|x.includes("6")|x.includes("9")
    if (name.startsWith("R-Struc-RepairFacility"))return .4
    if (name.startsWith("R-Cyborg-Metals"))return 0.2+cost/800
    if (name.startsWith("R-Vehicle-Metals"))return 0.2+cost/800


    if (name.startsWith("R-Struc-RprFac-Upgrade"))return 2-(enumDroid(me).filter(x=>x.health<50).length/30)+getResearch("R-Sys-Autorepair-General").done
    if (name.startsWith("R-Sys-Sensor-Upgrade"))return 1.5-name.endsWith("01")-hasRail*0.5
    if (name.startsWith("R-Vehicle-Engine"))return 2.1
    if (name.startsWith("R-Vehicle"))return 1.8-coefDroid*0.5
    if (name.startsWith("R-Struc"))return 1.9-coefDroid*0.5
    if (name.startsWith("R-Defense-WallUpgrade"))return 1.7+cost/500
    /*
    if (name.includes("Howitzer"))return 2.3-coefDroid*0.5-hasRail
    if (name.startsWith("R-Wpn-Mortar-Damage") || (name=="R-Defense-MortarPit" || name=="R-Defense-HvyMor") )return 2.5-coefDroid*0.5-hasRail+hasHowitzer
    if (name.startsWith("R-Wpn-Mortar02Hvy"))return 2.5-coefDroid*0.5-hasHowitzer-hasRail
    */
    if (name.startsWith("R-Sys"))return Math.max(1,2-playerPower(me)/10000)

    return 6
}

function goodCore(name="")
{
    var x=goodCount(name)
    if (name=="A0CommandCentre")return 0.7
    if (name=="A0ResearchFacility")return x*0.8-.2
    if (name=="A0LightFactory")return x-.21
    if (name=="A0CyborgFactory")return x-.3
    if (name=="A0VtolPad")return 0.6
    if (name=="A0PowerGenerator")return x-.6+playerPower(me)/2500
    return x
}

